      SUBROUTINE SETDH(EDIF, ADIF, FDIF, M, N, T0, TN, NSTEP, IPAR, 
     &                 RPAR, E, LDE, A, LDA, F, DH, LDDH, FH, RWORK, 
     &                 LRWORK)
C     .. Scalar Arguments..
      INTEGER          M, N, NSTEP, LRWORK
	DOUBLE PRECISION T0, TN
C     .. Array Arguments ..
      INTEGER          IPAR(*)
      DOUBLE PRECISION RPAR(*), E(LDE,*), A(LDA,*), F(*), DH(LDDH,*), 
     &                 RWORK(*), FH(*) 
C     .. Subroutine Arguments ..
      EXTERNAL         EDIF, ADIF, FDIF
C     .. Local Scalars ..
      INTEGER          I, J, ISTEP, IPOS, JPOS
	DOUBLE PRECISION H, TI
C     .. Executable Statements ..
      H = (TN - T0)/NSTEP
	CALL EDIF(M, N, H, IDIF, E, LDE, IPAR, RPAR, IERR)
	CALL ADIF(M, N, H, IDIF, A, LDA, IPAR, RPAR, IERR)
	CALL FDIF(M, H, IDIF, F, IPAR, RPAR, IERR)
	DO 10 I=1,M
	   FH(I) = H*F(I)
	   DO 10 J=1,N
	      DH(I,J) = E(I,J) - H*A(I,J)
  10  CONTINUE
      DO 100 ISTEP = 2, NSTEP
	   IPOS = (ISTEP-1)*M 
	   JPOS = (ISTEP-1)*N
         TI   = T0 + ISTEP*H
	   CALL EDIF(M, N, TI, IDIF, E, LDE, IPAR, RPAR, IERR)
	   CALL ADIF(M, N, TI, IDIF, A, LDA, IPAR, RPAR, IERR)
	   CALL FDIF(M, TI, IDIF, F, IPAR, RPAR, IERR)
	   DO 20 I=1,M
	      FH(IPOS+I) = H*F(I)
	      DO 20 J = 1,N
	         DH(IPOS+I, JPOS+J) = E(I,J) - H*A(I,J)
	         DH(IPOS+I, JPOS+J-N) = -E(I,J)
  20     CONTINUE
 100  CONTINUE
      RETURN
	END
